/*-
 * Copyright (c) 2007
 * Tatsuya Kudoh(CDR/TK),ROYALPANDA.    All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

package{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.media.*;
	import flash.text.*;
	import flash.utils.*;

	public class Snd {
		static private var bgm:Sound;
		static private var bgmChannel:SoundChannel;

		static public function play( type:int ):void {
			var s:Sound;

			s = Assets.sound(type);
			if( s )
				s.play();
		}

		static public function playBGM( type:int ):void {
			stopBGM();
			bgm = Assets.sound(type);
			if( bgm == null )
				return;
			bgmChannel = bgm.play();
			if( bgmChannel == null ){
				bgm = null;
				return;
			}
			bgmChannel.addEventListener(Event.SOUND_COMPLETE, loopBGM);
		}

		static public function stopBGM():void {
			if( bgmChannel == null )
				return;
			bgmChannel.stop();
			bgm = null;
			bgmChannel = null;
		}

		static public function loopBGM():void {
			if( bgm ){
				bgmChannel = bgm.play();
				if( bgmChannel == null ){
					bgm = null;
					return;
				}
				bgmChannel.addEventListener(Event.SOUND_COMPLETE, loopBGM);
			}
		}
	}
}
